proc principal {} {


ApacheSnapIn ap
#ApacheSnapIn ap2


set sh [[iwidgets::dialog .help] childsite].sh 
iwidgets::scrolledhtml $sh \
      -width 5i -height 3i \
      -wrap word -linkcommand "$sh import -link" -padx 10
	    
pack $sh -fill both -expand true 


.help delete Apply
.help delete Help


#####MENU######


createMenubar .   myHelpVbl   -tearoff 0 -contents {
cascade { -label "&Comanche" -help "" \
       -submenu {-contents {command {-label "Quit" -command "exit"}}}}\
cascade { -label "&Help" -help "" -submenu {-contents {\
         command {-label "Getting Started" -help ""\
	           -command {exec netscape docs/userguide.html &}\
		  }  \
         command {-label "Apache Help" -help ""\
	           -command {exec netscape  /home/httpd/html/manual/index.html &}
		   }  \
          command {-label "About" -help "" \
	           -command {exec netscape  html/about.html & }\
		  }  \
		  
}}} \
}


pack [label .l -textvariable myHelpVbl -justify left -anchor w -relief sunken]  -fill x -side bottom 

NameSpace MyNameSpace .ce
ConsoleScope .ce 
.ce AssocNameSpace MyNameSpace

ap Initialize MyNameSpace

.ce Load
pack .ce -expand yes -fill both  

global mytext
set mytext  [iwidgets::scrolledtext .st -height 100 -hscrollmode none]
pack $mytext -fill x -side bottom

}


proc View {IComponentData cookie} {

set info(cookie) $cookie
$IComponentData GetNodeInfo info

if ![winfo exists .view] {
iwidgets::dialog .view -modality application -title {Configuration} -height 100
#.view add ok -text OK -command {.view deactivate}
.view hide Apply
.view hide Help

pack [CfView [.view childsite].view -namespace MyNameSpace] -fill both -expand true
[.view childsite].view Init
}

[.view childsite].view Load  $info(CnfNode)
.view activate

}

class CfView {

public variable namespace
public variable mynode
private variable map

inherit itk::Widget 


constructor {args} {
  Widget::constructor
  array set map ""} {
itk_component add legend {message $itk_interior.legend -width 200 \
-text "Configuration file view" -justify left} {usual}
pack $itk_component(legend)  -pady 8 -fill x  -anchor n
 
 
itk_component add listbox {iwidgets::scrolledlistbox $itk_interior.listbox \
                           -vscrollmode dynamic -hscrollmode dynamic\
			   -selectmode single\
                           -relief sunken -borderwidth 4 \
			   -exportselection 0 } {usual}
 
itk_component add buttonbox {iwidgets::Buttonbox\
$itk_interior.bb -orient horizontal}
 
 
pack  $itk_component(buttonbox) -fill both \
-expand yes -side bottom  -anchor n
pack $itk_component(listbox) -fill both -expand true -pady 4 -side top\
-anchor n

 
eval itk_initialize $args
      

}  

public method Init {} {

    $itk_component(buttonbox) add Add -text Add... \
-command "AddElementNode $this; $this Refresh "
$itk_component(buttonbox) add Delete -text Delete \
-command "DeleteElementNode $this; $this Refresh "
$itk_component(buttonbox) add Edit -text Edit... \
-command "EditElementNode $this;  $this Refresh"
$itk_component(listbox) configure -dblclickcommand "EditElementNode \
$this; $this Refresh"
 


}

public method Map { position } {

    return $map($position)

}

public method Load {parentnode} {

	$itk_component(listbox) delete 0 end

    set j 0
	foreach node [$parentnode ext_contents dir_class directive] {
	    $itk_component(listbox) insert end [$node get_data dir_value]
	    set map($j) $node
	    incr j
	}
	$this configure -mynode $parentnode

	#$this sort ascending

}

public method Refresh {} {

	$this Load [$this cget -mynode]
}



public method clear {} {

	$itk_component(listbox) delete 0 end

}
}


proc PageDispatcher {container pagename dir_info control_info ppage } {

#       1st element: directive info tree
#	  2nd element: control info node
#       3rd element: ppages definition node  
#  	  En el futuro pasar un solo parametro, el del arbol de configuracion y de hay ya se sabe lo que cuelga

set mypage [$ppage ext_contents name $pagename]

if { $mypage == "" } {  error!  the page $pagename does not exist }

# Create a labeled widget in container (name = site)

# Foreach element in the page

set control_list ""

foreach element $mypage {

	switch [$element get_data type]  group {
	# If it is a group, create group
	set group [CreateGroup $lgrid $element]
	
		foreach control [ $element contents ] {

		# Foreach element in the group, create controls
		# This has to be changed in the future if we want groups inside groups, etc
		# By now it is ok

		lappend control_list [CreateControl $lgrid $group $control]


		}

	}

	# pack si hay que pack algo

}


return control_list

}


proc CreateControl { lgrid group control} {

# group: name of the group to which it belongs
# lgrid: labeled grid where to add it
# control: pointing to the CCF tree where it is defined


# Extract information from the control node, and substitute it for defaults if it does not exists
# Specifically: type of control (list, bdir, etc)
# 		   name of the directive

}

proc ControlDispatcher {controlname control} {

}


proc PageWebSite {container} {

iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \

#        -height 800 -width 800

      
set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -columnspan 2 -padx 2 -pady 2 

$w.l group wi -label "Web Site Identification"  -rowspan 5 -columnspan 2 -sticky news
$w.l add bdir wi.servername -columnspan 2 -directive_info_tree cdir  -control_info_node [temp ext_contents name servername] -width 20
$w.l add bdir wi.serveradmin -columnspan 2 -directive_info_tree cdir -control_info_node [temp ext_contents name serveradmin] -width 20
$w.l add bdir wi.user -columnspan 1 -directive_info_tree cdir  -control_info_node [temp ext_contents name user] 
$w.l add bdir wi.group -columnspan 1 -directive_info_tree cdir -control_info_node [temp ext_contents name group] 
$w.l add choice wi.servertype -columnspan 2 -directive_info_tree cdir -confnode [cnftree GetRoot] -control_info_node [temp ext_contents name servertype] -width 20

iwidgets::Labeledwidget::alignlabels [$w.l component wi.serveradmin] [$w.l component wi.servername] 
iwidgets::Labeledwidget::alignlabels [$w.l component wi.group] [$w.l component wi.user]

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return [list [$w.l component wi.serveradmin] [$w.l component wi.servername]  [$w.l component wi.group] [$w.l component wi.user] \
[$w.l component wi.servertype] ]


}

proc PageListening {container} {

iwidgets::scrolledframe $container.frame \
        -hscrollmode dynamic -vscrollmode dynamic \
        -height 800 -width 800

set w [$container.frame childsite]
labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2

$w.l group sl -label "Server Listening"  -rowspan 5 -columnspan 2
$w.l add bdir sl.bindaddress -columnspan 1 -directive_info_tree cdir  -control_info_node [temp ext_contents name bindaddress] 
$w.l add bdir sl.port -columnspan 1 -directive_info_tree cdir  -control_info_node [temp ext_contents name port] 

$w.l group asl -label "Advanced Server Listening"  -rowspan 5 -columnspan 2
$w.l add list2 asl.listen -columnspan 2 -directive_info_tree cdir  -control_info_node [temp ext_contents name listen] 

#iwidgets::Labeledwidget::alignlabels [$w.l component sl.servertype] [$w.l component sl.bindaddress] 

pack $w.l -fill both  -expand true
pack $container.frame -fill both -expand true

return [list [$w.l component sl.bindaddress]\
[$w.l component sl.port] [$w.l component asl.listen]  ]
}

proc PagePerformance {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2

$w.l group bps -label "Basic performance settings"  -rowspan 5 -columnspan 1 -childcolumnspan 1

$w.l add bdir bps.startservers -directive_info_tree cdir  -control_info_node [temp ext_contents name startservers] 
$w.l add bdir bps.minspareservers -directive_info_tree cdir  -control_info_node [temp ext_contents name minspareservers] 
$w.l add bdir bps.maxspareservers -directive_info_tree cdir  -control_info_node [temp ext_contents name maxspareservers] 
$w.l add bdir bps.maxrequestsperchild -directive_info_tree cdir  -control_info_node [temp ext_contents name maxrequestsperchild] 

iwidgets::Labeledwidget::alignlabels [$w.l component bps.minspareservers] [$w.l component bps.maxspareservers] \
[$w.l component bps.maxrequestsperchild] [$w.l component bps.startservers] 

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return [list  [$w.l component bps.minspareservers] [$w.l component bps.maxspareservers] \
[$w.l component bps.maxrequestsperchild] [$w.l component bps.startservers]]

}


proc PageKeepAlive {container} {

iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]
labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2

$w.l group ka -label "Keep alive"  -rowspan 5 -columnspan 1 -childcolumnspan 1

$w.l add boolean2 ka.keepalive -directive_info_tree cdir  -control_info_node [temp ext_contents name keepalive] -columnspan 2
$w.l add bdir ka.keepalivetimeout -directive_info_tree cdir  -control_info_node [temp ext_contents name keepalivetimeout] 
$w.l add bdir ka.maxkeepaliverequests -directive_info_tree cdir  -control_info_node [temp ext_contents name maxkeepaliverequests] 

iwidgets::Labeledwidget::alignlabels [$w.l component ka.keepalivetimeout] \
[$w.l component ka.maxkeepaliverequests] 

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return [list [$w.l component ka.keepalivetimeout] \
[$w.l component ka.maxkeepaliverequests] [$w.l component ka.keepalive]]
}

proc PageAdvanced {container} {

iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 2 -columnspan 1 -padx 2 -pady 2

$w.l group apt -label "Advanced Performance Settings"  -rowspan 1

$w.l add popformore apt.apt -directive_info_tree cdir  -control_info_node [temp ext_contents name advancedtuning] -columnspan 2

#iwidgets::Labeledwidget::alignlabels [$w.l component ka.keepalivetimeout] \
#[$w.l component ka.maxkeepaliverequests] 

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true


return 

#Noretornamos nada

}

proc PageCgi {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2

$w.l group cs -label "CGI Scripts"  -rowspan 5 

$w.l add bdir cs.scriptlog -directive_info_tree cdir  -control_info_node [temp ext_contents name scriptlog] -columnspan 1
$w.l add bdir cs.scriptloglength -directive_info_tree cdir  -control_info_node [temp ext_contents name scriptloglength] 
$w.l add bdir cs.scriptlogbuffer -directive_info_tree cdir  -control_info_node [temp ext_contents name scriptlogbuffer] 

iwidgets::Labeledwidget::alignlabels [$w.l component cs.scriptlog] [$w.l component cs.scriptloglength] \
[$w.l component cs.scriptlogbuffer]


pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return [list [$w.l component cs.scriptlog] [$w.l component cs.scriptloglength] \
[$w.l component cs.scriptlogbuffer] ]

}

proc PageEnvironment {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group env -label "Environment"  -rowspan 5 
$w.l add radionb2 env.envars -directive_info_tree cdir  -control_info_node [temp ext_contents name envars] -columnspan 1
#

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component env.envars ] ]

#[env.kk env.kk2]

}


proc PageLogs {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group logs -label "Log Files"  -rowspan 5 
$w.l add compound logs.files -directive_info_tree cdir  -control_info_node [temp ext_contents name logs] -columnspan 1

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component logs.files ]]

#[env.kk env.kk2]

}

proc PageLogsAdvanced {container } {
iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group logsadvanced -label "Logging checks"  -rowspan 5 
$w.l add choice logsadvanced.hnl -directive_info_tree cdir  -control_info_node [temp ext_contents name hostnamelookups] -columnspan 1
$w.l add choice logsadvanced.llevel -directive_info_tree cdir  -control_info_node [temp ext_contents name loglevel] -columnspan 1
$w.l add boolean2 logsadvanced.icheck -directive_info_tree cdir  -control_info_node [temp ext_contents name identitycheck] -columnspan 1


pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component logsadvanced.llevel ] [$w.l component logsadvanced.icheck ] [$w.l component logsadvanced.hnl ]]

#[env.kk env.kk2]

}




proc PageMIME {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group mime -label "MIME"  -rowspan 5 
$w.l add radionb2 mime.mime -directive_info_tree cdir  -control_info_node [temp ext_contents name mime] -columnspan 1
#

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component mime.mime ] ]

#[env.kk env.kk2]

}

proc PageDirectoryTuningAdvanced {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group iconalt -label "Icons and Descriptions"  -rowspan 5 
$w.l add bdir iconalt.deficon -directive_info_tree cdir  -control_info_node [temp ext_contents name defaulticon] -columnspan 1
$w.l add radionb2 iconalt.iconalt -directive_info_tree cdir  -control_info_node [temp ext_contents name iconalt] -columnspan 1
#

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component iconalt.iconalt ] [$w.l component iconalt.deficon ]]

#[env.kk env.kk2]

}


proc PageProxy {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group proxy -label "Proxy settings"  -rowspan 5 
$w.l add boolean proxy.proxy -directive_info_tree cdir  -control_info_node [temp ext_contents name proxyrequests] -columnspan 1
$w.l group proxyrules -label "Operation"  -rowspan 5 
$w.l add radionb proxyrules.rules1 -directive_info_tree cdir  -control_info_node [temp ext_contents name proxyrules1] -columnspan 1

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list  [$w.l component proxyrules.rules1] [$w.l component proxy.proxy]]
#return  [list  [$w.l component proxy.proxy]]

#[env.kk env.kk2]

}


proc PageProxyMapping {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group proxyrules -label "Mapping"  -rowspan 5 
$w.l add radionb2 proxyrules.rules2 -directive_info_tree cdir  -control_info_node [temp ext_contents name proxyrules2] -columnspan 1

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [$w.l component proxyrules.rules2 ]

#[env.kk env.kk2]

}

proc PageProxyCache {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group proxy -label "Cache"  -rowspan 5 
$w.l add compound proxy.cache -directive_info_tree cdir  -control_info_node [temp ext_contents name cache] -columnspan 1

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [$w.l component proxy.cache ]

#[env.kk env.kk2]

}
proc PageDirectoryTuning {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group dirtun -label "Directory indexing options"  -rowspan 5 
$w.l add boolean dirtun.fancyidx -directive_info_tree cdir  -control_info_node [temp ext_contents name fancyindexing] -columnspan 1
$w.l add list dirtun.diridx -directive_info_tree cdir  -control_info_node [temp ext_contents name indexoptions] -columnspan 1


pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component dirtun.diridx ] [$w.l component dirtun.fancyidx ]]

#[env.kk env.kk2]

}


proc PageDirectoryHeaders {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group dirhd -label "File options"  -rowspan 5 
$w.l add  radionb2 dirhd.files -directive_info_tree cdir  -control_info_node [temp ext_contents name dirfiles] -columnspan 1


pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component dirhd.files ] ]

#[env.kk env.kk2]

}


proc ApacheCtl {action } {
global tcl_platform

if {$tcl_platform(platform) == "windows"} { 

set agdummy "Apache Group"

switch $action start {

open "|[file join [registry get HKEY_LOCAL_MACHINE\\SOFTWARE\\$agdummy\\Apache\\1.3.3 ServerRoot] apache.exe] -s"

} stop {    

open "|[file join [registry get HKEY_LOCAL_MACHINE\\SOFTWARE\\$agdummy\\Apache\\1.3.3 ServerRoot] apache.exe] -s -k shutdown"

} restart {
open "|[file join [registry get HKEY_LOCAL_MACHINE\\SOFTWARE\\$agdummy\\Apache\\1.3.3 ServerRoot] apache.exe] -s -k restart"
}

} else {

switch $action start { 
#set newchannel [open "|apachectl start"]
set newchannel [open "|/etc/rc.d/init.d/httpd start"]
fileevent $newchannel readable "fill_widget  $newchannel"

} stop {
#set newchannel [open "|apachectl stop"]
set newchannel [open "|/etc/rc.d/init.d/httpd stop"]
fileevent $newchannel readable "fill_widget  $newchannel"
	    
	        } restart { 
		
#set newchannel [open "|apachectl restart"]
set newchannel [open "|/etc/rc.d/init.d/httpd restart"]
fileevent $newchannel readable "fill_widget  $newchannel"
		} status {
		set newchannel [open "|/etc/rc.d/init.d/httpd status"]
fileevent $newchannel readable "fill_widget  $newchannel"
		
		}
# hardcoded path. Change (or write tcl procedure)
}

}

proc fill_widget {handler} {
global mytext
$mytext yview end
set a [gets $handler]
if [string length [string trim $a]] {
   $mytext insert end $a   
  $mytext insert end "\n"
}


if [eof $handler] {close $handler}
}
proc CreateControlStuff {container} {

set con [$container childsite]
frame $con.f
set w [frame $con.f.f -relief groove -borderwidth 3]

set start [iwidgets::labeledwidget $w.start -labeltext "Start"  ]
pack $start  -side left -expand yes -fill x -side top  -padx 2 -pady 2 -anchor w
pack [ button [$start childsite].button  -height 26 -width 26 -image start \
-command {ApacheCtl start}] -padx 2 -pady 2 -anchor w 

set stop [iwidgets::labeledwidget $w.stop -labeltext "Stop" ]
pack $stop -side left -expand yes -fill x -side top  -padx 2 -pady 2 -anchor w
pack [ button [$stop childsite].button  -height 26 -width 26 -image stop \
-command {ApacheCtl stop} ] -padx 2 -pady 2 -anchor w 


set restart [iwidgets::labeledwidget $w.restart -labeltext "Restart" ]
pack $restart -side left -expand yes -fill x -side top  -padx 2 -pady 2 -anchor w
pack [ button [$restart childsite].button  -height 26 -width 26 -image restart \
-command {ApacheCtl restart}] -padx 2 -pady 2 -anchor w 

iwidgets::Labeledwidget::alignlabels $w.stop $w.start $w.restart

pack $w -fill both  -padx 2 -pady 2 -side left



pack $con.f -expand true -fill x

set w [frame $con.f2 -relief groove -borderwidth 3]

set save [iwidgets::labeledwidget $w.save -labeltext "Save actual config"  ]
pack $save  -side left -expand yes -fill x -side left  -padx 2 -pady 2 -anchor w
pack [ button [$save childsite].button  -height 26 -width 26 -image save \
-command "cnftree Save \[cnftree GetRoot\]" ] -padx 2 -pady 2 -anchor w
#### cambiar ese cnftree a algo general

set oldconf [iwidgets::labeledwidget $w.oldconf -labeltext "Past Configurations..." ]
pack $oldconf -side left -expand yes -fill x -side left  -padx 2 -pady 2 -anchor w
pack [ button [$oldconf childsite].button  -height 26 -width 26 -image oldconf] -padx 2 -pady 2 -anchor w

pack $w -fill x -expand true -padx 2 -pady 2 -anchor e

}



###############################################################################################333
#For virtual hosts now
###############################################################################################333


proc PageWebSiteVirtualHost {container} {

iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

      
set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2 

$w.l group wi -label "Web Site Identification"  -rowspan 5 -columnspan 1 -sticky news
$w.l add bdir wi.servername -directive_info_tree cdir  -control_info_node [temp ext_contents name servername] -width 20
$w.l add bdir wi.serveradmin -directive_info_tree cdir  -control_info_node [temp ext_contents name serveradmin] -width 20

iwidgets::Labeledwidget::alignlabels [$w.l component wi.serveradmin] [$w.l component wi.servername] 

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return [list [$w.l component wi.serveradmin] [$w.l component wi.servername]]

}

proc PageLogsVirtualHost {container} {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group logs -label "Log Files"  -rowspan 5 
$w.l add compound logs.files -directive_info_tree cdir  -control_info_node [temp ext_contents name logsvirtualhost] -columnspan 1

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component logs.files ]]


}



proc PageEnvironmentVirtualHost {container } {


iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group env -label "Environment"  -rowspan 5 
$w.l add radionb2 env.envars -directive_info_tree cdir  -control_info_node [temp ext_contents name envarsvirtualhost] -columnspan 1
#

pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component env.envars ] ]

#[env.kk env.kk2]

}




#####################3333
# Directory
##############3

proc PageLogsDirectory {container } {
iwidgets::scrolledframe $container.frame \
        -hscrollmode none -vscrollmode none \
        -height 800 -width 800

set w [$container.frame childsite]

labeledgrid $w.l  -childstyle boxed  -childcolumnspan 1 -columnspan 1 -padx 2 -pady 2


$w.l group logsadvanced -label "Logging checks"  -rowspan 5 
$w.l add choice logsadvanced.hnl -directive_info_tree cdir  -control_info_node [temp ext_contents name hostnamelookups] -columnspan 1
$w.l add boolean2 logsadvanced.icheck -directive_info_tree cdir  -control_info_node [temp ext_contents name identitycheck] -columnspan 1


pack $container.frame -fill both -expand true
pack $w.l -fill both  -expand true

return  [list [$w.l component logsadvanced.icheck] [$w.l component logsadvanced.hnl ]]


}


