class control_radionb  {

inherit itk::Widget Bean Node

public variable control_info_node
#public variable directives
public variable directive_info_tree
public variable confnode
private variable map
private variable conf

constructor {args} { Widget::constructor} {

array set map ""
array set conf ""

itk_component add notebook {iwidgets::notebook $itk_interior.nb  }
pack $itk_component(notebook) -fill both -expand yes -side right -padx 4 -pady 4

itk_component add radio {iwidgets::radiobox $itk_interior.rb  }
pack $itk_component(cb) -fill both -expand yes -side left -padx 4 -pady 4

eval itk_initialize $args
}


public method initialize {}
public method load {}
public method save {} { }
}

body control_radionb::initialize {} {

array set conf [$control_info_node get_data]
set directives [$directive_info_tree ext_contents directive $conf(directives)]

foreach directive $conf(directives) {

	$itk_component(rb) add $directive -text $conf($directive.text) -command { $itk_component(notebook) view [$itk_component(rb) get] }

	itk_component add lb.$directive {
		control_list [$itk_component(notebook) add $directive].lb
	}

	$itk_component(lb.$directive) configure -directive_info_tree $directive_info_tree  -confnode $conf_node -control_info_node 	$control_info_node

	$itk_component(lb.$directive) initialize
	$itk_component(lb.$directive) load
	pack $itk_component(lb.$directive) -fill both -expand true 

	}

}

body control_radionb::load {} {

}

